<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:swid="http://standards.iso.org/iso/19770/-2/2015/schema.xsd"
  xmlns:xmldsig="http://www.w3.org/2000/09/xmldsig#"
  xmlns="http://standards.iso.org/iso/19770/-2/2015/schema.xsd"
  exclude-result-prefixes="swid xmldsig"
  >

<xsl:param name="version" />
<xsl:param name="arch" />

<xsl:param name="revision" />
<xsl:param name="edition" />

<xsl:template match="/">
  <xsl:if test="not($version)">
    <xsl:message terminate="yes">Parameter version was not provided.</xsl:message>
  </xsl:if>
  <xsl:if test="not($arch)">
    <xsl:message terminate="yes">Parameter arch was not provided.</xsl:message>
  </xsl:if>
  <xsl:apply-templates select="*"/>
</xsl:template>

<xsl:template match="swid:SoftwareIdentity">
  <xsl:copy>
    <xsl:attribute name="version"><xsl:value-of select="$version" /></xsl:attribute>
    <xsl:apply-templates select="@*|*"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="@tagId">
  <xsl:attribute name="tagId">
    <xsl:value-of select="." />-<xsl:value-of select="$version" />
    <xsl:if test="$revision">-<xsl:value-of select="$revision" /></xsl:if>
    <xsl:value-of select="'-'" /><xsl:value-of select="$arch" />
  </xsl:attribute>
</xsl:template>

<xsl:template match="swid:Meta">
  <xsl:copy>
    <xsl:attribute name="colloquialVersion"><xsl:value-of select="$version" /></xsl:attribute>
    <xsl:attribute name="revision"><xsl:value-of select="$revision" /></xsl:attribute>
    <xsl:attribute name="edition"><xsl:value-of select="$edition" /></xsl:attribute>
    <xsl:attribute name="arch"><xsl:value-of select="$arch" /></xsl:attribute>
    <xsl:apply-templates select="@*|*" />
  </xsl:copy>
</xsl:template>

<xsl:template match="@*|node()">
  <xsl:copy>
    <xsl:apply-templates select="@*|*" />
  </xsl:copy>
</xsl:template>

<xsl:template match="xmldsig:Signature">
  <!-- remove the signature input from input for now -->
</xsl:template>

</xsl:stylesheet>
